package uk.ac.cf.spring.demo.takeaway.index;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.List;

@Controller
public class ExchangeController {
//    page /exchangeItemList
    @GetMapping("/exchange")
    public ModelAndView getExchange() {
        ModelAndView modelAndView = new ModelAndView("/page/itemList");
        ExchangeService exchangeService =ExchangeService.getInstance();
        List<ExchangeItem> exchangeItems =exchangeService.getExchangeItems();
        modelAndView.addObject("exchangeItems", exchangeItems);
        return modelAndView;
    }
//    page /exchangeItemDetail
    @GetMapping("/exchange/{id}")
    public ModelAndView getExchangeItem(@PathVariable Long id) {
        ModelAndView modelAndView = new ModelAndView("/page/itemDetail");
        ExchangeService exchangeService = ExchangeService.getInstance();
        ExchangeItem exchangeItem = exchangeService.getExchangeItem(id);
        modelAndView.addObject("exchangeItem", exchangeItem);
        return modelAndView;
    }
//    add new ExchangeItem
    @GetMapping("/exchange/add")
    public ModelAndView addExchangeItem() {
        ModelAndView modelAndView = new ModelAndView("/page/itemForm");
        return modelAndView;
    }
    // address form
    @PostMapping("/exchangeItem")
    public ModelAndView addExchangeItem(ExchangeItem exchangeItem) {
        ExchangeService exchangeService = ExchangeService.getInstance();
        exchangeService.addExchangeItem(exchangeItem);
        ModelAndView modelAndView = new ModelAndView("redirect:/exchange");
        return modelAndView;
    }
}
