package uk.ac.cf.spring.demo.takeaway.index;

import java.util.ArrayList;
import java.util.List;

public class ExchangeService {
    private List<ExchangeItem> exchangeItems;

    private static ExchangeService singleton;
    private ExchangeService() {
        exchangeItems = new ArrayList<>();
        exchangeItems.addAll(List.of(
                new ExchangeItem(1L, "oldClothes ", "Useless Old clothes, suitable for teenager", true, false),
                new ExchangeItem(2L, "oldToy ", "Useless Old toys, suitable for kid", true, true),
                new ExchangeItem(3L, "oldPens ", "Useless Old pens, suitable for adult", true, false),
                new ExchangeItem(4L, "oldShoes ", "Useless Old clothes, suitable for teenager and adult", false, true)
        ));
    }
    // get instance
    public static ExchangeService getInstance() {
        if (singleton == null) {
            singleton = new ExchangeService();
        }
        return singleton;
    }
    public List<ExchangeItem> getExchangeItems() {
        return exchangeItems;
    }
    // through id to search exchangeItem
    public ExchangeItem getExchangeItem(Long id) {
        return exchangeItems.stream().filter(exchangeItem ->
                exchangeItem.getId().equals(id)).findFirst().orElse(null);
    }
    //    add post information to exchangeItem service own data
    public void addExchangeItem(ExchangeItem exchangeItem) {
        Long maxId =
                exchangeItems.stream().mapToLong(ExchangeItem::getId).max().orElse(0L);
        maxId++;
        exchangeItem.setId(maxId);
        exchangeItems.add(exchangeItem);
    }

}
